/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SnapchatConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SnapchatConnectorForm{}

// SnapchatConnectorForm struct for SnapchatConnectorForm
type SnapchatConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// OAuth Identifier
	OAuthId string `json:"oAuthId"`
	// Label
	Label string `json:"label"`
	// Snapchat Organization identifier
	OrganizationId string `json:"organizationId"`
	// Snapchat Ad Account identifier
	AccountId string `json:"accountId"`
	// Metrics
	Metrics []string `json:"metrics"`
	// Labels
	Labels []string `json:"labels"`
	// breakdown
	Breakdown string `json:"breakdown"`
	// Data range
	DateRange string `json:"dateRange"`
	// action_report_time
	ActionReportTime string `json:"action_report_time"`
	// swipe_up_attribution_window
	SwipeUpAttributionWindow string `json:"swipe_up_attribution_window"`
	// view_attribution_window
	ViewAttributionWindow string `json:"view_attribution_window"`
}

// NewSnapchatConnectorForm instantiates a new SnapchatConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSnapchatConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, organizationId string, accountId string, metrics []string, labels []string, breakdown string, dateRange string, actionReportTime string, swipeUpAttributionWindow string, viewAttributionWindow string) *SnapchatConnectorForm {
	this := SnapchatConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.OrganizationId = organizationId
	this.AccountId = accountId
	this.Metrics = metrics
	this.Labels = labels
	this.Breakdown = breakdown
	this.DateRange = dateRange
	this.ActionReportTime = actionReportTime
	this.SwipeUpAttributionWindow = swipeUpAttributionWindow
	this.ViewAttributionWindow = viewAttributionWindow
	return &this
}

// NewSnapchatConnectorFormWithDefaults instantiates a new SnapchatConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSnapchatConnectorFormWithDefaults() *SnapchatConnectorForm {
	this := SnapchatConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *SnapchatConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *SnapchatConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *SnapchatConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *SnapchatConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *SnapchatConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *SnapchatConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *SnapchatConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *SnapchatConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *SnapchatConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *SnapchatConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *SnapchatConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *SnapchatConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *SnapchatConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *SnapchatConnectorForm) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *SnapchatConnectorForm) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetAccountId returns the AccountId field value
func (o *SnapchatConnectorForm) GetAccountId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetAccountIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AccountId, true
}

// SetAccountId sets field value
func (o *SnapchatConnectorForm) SetAccountId(v string) {
	o.AccountId = v
}

// GetMetrics returns the Metrics field value
func (o *SnapchatConnectorForm) GetMetrics() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Metrics
}

// GetMetricsOk returns a tuple with the Metrics field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetMetricsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Metrics, true
}

// SetMetrics sets field value
func (o *SnapchatConnectorForm) SetMetrics(v []string) {
	o.Metrics = v
}

// GetLabels returns the Labels field value
func (o *SnapchatConnectorForm) GetLabels() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetLabelsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Labels, true
}

// SetLabels sets field value
func (o *SnapchatConnectorForm) SetLabels(v []string) {
	o.Labels = v
}

// GetBreakdown returns the Breakdown field value
func (o *SnapchatConnectorForm) GetBreakdown() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Breakdown
}

// GetBreakdownOk returns a tuple with the Breakdown field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetBreakdownOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Breakdown, true
}

// SetBreakdown sets field value
func (o *SnapchatConnectorForm) SetBreakdown(v string) {
	o.Breakdown = v
}

// GetDateRange returns the DateRange field value
func (o *SnapchatConnectorForm) GetDateRange() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DateRange, true
}

// SetDateRange sets field value
func (o *SnapchatConnectorForm) SetDateRange(v string) {
	o.DateRange = v
}

// GetActionReportTime returns the ActionReportTime field value
func (o *SnapchatConnectorForm) GetActionReportTime() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ActionReportTime
}

// GetActionReportTimeOk returns a tuple with the ActionReportTime field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetActionReportTimeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ActionReportTime, true
}

// SetActionReportTime sets field value
func (o *SnapchatConnectorForm) SetActionReportTime(v string) {
	o.ActionReportTime = v
}

// GetSwipeUpAttributionWindow returns the SwipeUpAttributionWindow field value
func (o *SnapchatConnectorForm) GetSwipeUpAttributionWindow() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SwipeUpAttributionWindow
}

// GetSwipeUpAttributionWindowOk returns a tuple with the SwipeUpAttributionWindow field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetSwipeUpAttributionWindowOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SwipeUpAttributionWindow, true
}

// SetSwipeUpAttributionWindow sets field value
func (o *SnapchatConnectorForm) SetSwipeUpAttributionWindow(v string) {
	o.SwipeUpAttributionWindow = v
}

// GetViewAttributionWindow returns the ViewAttributionWindow field value
func (o *SnapchatConnectorForm) GetViewAttributionWindow() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ViewAttributionWindow
}

// GetViewAttributionWindowOk returns a tuple with the ViewAttributionWindow field value
// and a boolean to check if the value has been set.
func (o *SnapchatConnectorForm) GetViewAttributionWindowOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ViewAttributionWindow, true
}

// SetViewAttributionWindow sets field value
func (o *SnapchatConnectorForm) SetViewAttributionWindow(v string) {
	o.ViewAttributionWindow = v
}

func (o SnapchatConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SnapchatConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["organizationId"] = o.OrganizationId
	toSerialize["accountId"] = o.AccountId
	toSerialize["metrics"] = o.Metrics
	toSerialize["labels"] = o.Labels
	toSerialize["breakdown"] = o.Breakdown
	toSerialize["dateRange"] = o.DateRange
	toSerialize["action_report_time"] = o.ActionReportTime
	toSerialize["swipe_up_attribution_window"] = o.SwipeUpAttributionWindow
	toSerialize["view_attribution_window"] = o.ViewAttributionWindow
	return toSerialize, nil
}

type NullableSnapchatConnectorForm struct {
	value *SnapchatConnectorForm
	isSet bool
}

func (v NullableSnapchatConnectorForm) Get() *SnapchatConnectorForm {
	return v.value
}

func (v *NullableSnapchatConnectorForm) Set(val *SnapchatConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableSnapchatConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableSnapchatConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSnapchatConnectorForm(val *SnapchatConnectorForm) *NullableSnapchatConnectorForm {
	return &NullableSnapchatConnectorForm{value: val, isSet: true}
}

func (v NullableSnapchatConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSnapchatConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
